(require '#:cmp)
(require '#:asdf)

(setf c::*debug-compiler* t)

(defparameter *cffi-location* #P"~/software/lisp/cffi_0.9.2/")

(when (probe-file *cffi-location*)
  (pushnew *cffi-location* asdf:*central-registry*))

(handler-case (asdf:find-system '#:cffi)
  (error (e)
    (format t "Couldn't find CFFI, set the *cffi-location* in this file.~%  ~a~%" e)
    (ext:quit)))

(ext:run-program "gcc" '("-W" "-Wall" "-shared" "-fPIC" "-o" "run_function.so" "run_function.c")
                 :input nil :output t :error t)

(asdf:make-build "program" :type :program
                 :args (list :epilogue-code '(main)))

(ext:quit)